Index: palm/trunk/SOURCE/pmc_client.f90
===================================================================
--- palm/trunk/SOURCE/pmc_client.f90	(revision 1777)
+++ palm/trunk/SOURCE/pmc_client.f90	(revision 1779)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! kind=dp replaced by wp, dim_order removed
+! array management changed from linked list to sequential loop
 !
 ! Former revisions:
@@ -50,5 +51,5 @@
     USE  kinds
     USE  PMC_general,   ONLY: ClientDef, DA_NameDef, DA_Namelen, PMC_STATUS_OK, PMC_DA_NAME_ERR, PeDef, ArrayDef, &
-                                         DA_Desclen, DA_Namelen, PMC_G_SetName, PMC_G_GetName
+                                         DA_Desclen, DA_Namelen, PMC_G_SetName, PMC_MAX_ARRAY
     USE  PMC_handle_communicator,   ONLY: m_model_comm,m_model_rank,m_model_npes, m_to_server_comm
     USE  PMC_MPI_wrapper,           ONLY: PMC_Send_to_Server, PMC_Recv_from_Server, PMC_Time,                     &
@@ -58,11 +59,8 @@
     SAVE
 
-!   data local to this MODULE
     Type(ClientDef)                       :: me
-!-- TO_DO: what is the meaning of this? Could variables declared in this module
-!--        also have single precision?
-!    INTEGER, PARAMETER                    :: dp = wp
-
-    INTEGER, save                         :: myIndex = 0                !Counter and unique number for Data Arrays
+
+    INTEGER                               :: next_array_in_list = 0
+    INTEGER                               :: myIndex = 0                !Counter and unique number for Data Arrays
 
     ! INTERFACE section
@@ -81,4 +79,8 @@
     END INTERFACE PMC_C_Get_2D_index_list
 
+    INTERFACE PMC_C_clear_next_array_list
+        MODULE procedure PMC_C_clear_next_array_list
+    END INTERFACE PMC_C_clear_next_array_list
+
     INTERFACE PMC_C_GetNextArray
         MODULE procedure PMC_C_GetNextArray
@@ -105,6 +107,6 @@
 
     PUBLIC PMC_ClientInit , PMC_Set_DataArray_Name, PMC_C_Get_2D_index_list
-    PUBLIC PMC_C_GetNextArray, PMC_C_Set_DataArray
-    PUBLIC PMC_C_setInd_and_AllocMem , PMC_C_GetBuffer, PMC_C_PutBuffer ! ,PMC_C_GetServerType
+    PUBLIC PMC_C_GetNextArray, PMC_C_Set_DataArray, PMC_C_clear_next_array_list
+    PUBLIC PMC_C_setInd_and_AllocMem , PMC_C_GetBuffer, PMC_C_PutBuffer
 
 CONTAINS
@@ -130,9 +132,10 @@
         CALL MPI_Intercomm_merge (me%inter_comm, .true., me%intra_comm, istat);
         CALL MPI_Comm_rank (me%intra_comm, me%intra_rank, istat);
-
         ALLOCATE (me%PEs(me%inter_npes))
 
+!
+!--     Allocate for all Server PEs an array of TYPE ArrayDef to store information of transfer array
         do i=1,me%inter_npes
-           NULLIFY(me%PEs(i)%Arrays)
+           ALLOCATE(me%PEs(i)%array_list(PMC_MAX_ARRAY))
         end do
 
@@ -142,5 +145,5 @@
     END SUBROUTINE PMC_ClientInit
 
-    SUBROUTINE PMC_Set_DataArray_Name (ServerArrayDesc, ServerArrayName, ClientArrayDesc, ClientArrayName, istat, LastEntry)
+    SUBROUTINE PMC_Set_DataArray_Name (ServerArrayDesc, ServerArrayName, ClientArrayDesc, ClientArrayName, istat)
         IMPLICIT none
         character(len=*),INTENT(IN)           :: ServerArrayName
@@ -149,5 +152,4 @@
         character(len=*),INTENT(IN)           :: ClientArrayDesc
         INTEGER,INTENT(OUT)                   :: istat
-        LOGICAL,INTENT(IN),optional           :: LastEntry
 
         !-- local variables
@@ -192,8 +194,4 @@
         CALL PMC_Bcast ( myName%NameOnClient, myPE, comm=m_to_server_comm)
 
-        if(present (LastEntry))   then
-            CALL PMC_Set_DataArray_Name_LastEntry ( LastEntry = LastEntry)
-        end if
-
         CALL PMC_G_SetName (me, myName%couple_index, myName%NameOnClient)
 
@@ -231,5 +229,5 @@
        INTEGER(KIND=MPI_ADDRESS_KIND)          :: disp            !: Displacement Unit (Integer = 4, floating poit = 8
        INTEGER,DIMENSION(me%inter_npes*2)      :: NrEle           !: Number of Elements of a horizontal slice
-       TYPE(PeDef),POINTER                     :: aPE             !: Pointer to PeDef strzcture
+       TYPE(PeDef),POINTER                     :: aPE             !: Pointer to PeDef structure
        INTEGER(KIND=MPI_ADDRESS_KIND)          :: WinSize         !: Size of MPI window 2 (in bytes)
        INTEGER,DIMENSION(:),POINTER            :: myInd
@@ -299,36 +297,50 @@
     END SUBROUTINE PMC_C_Get_2D_index_list
 
+    SUBROUTINE PMC_C_clear_next_array_list
+       IMPLICIT none
+
+       next_array_in_list = 0
+
+       return
+    END SUBROUTINE PMC_C_clear_next_array_list
+
+!   List handling is still required to get minimal interaction with pmc_interface
     LOGICAL function PMC_C_GetNextArray (myName)
         character(len=*),INTENT(OUT)               :: myName
 
         !-- local variables
-        INTEGER                      :: MyCoupleIndex
-        LOGICAL                      :: MyLast                             !Last Array in List
-        character(len=DA_Namelen)    :: loName
-
-        loName = 'NoName '
-        MyLast = .true.
-
-        CALL PMC_G_GetName (me, MyCoupleIndex, loName, MyLast)
-
-        myName = trim(loName)
-
-        PMC_C_GetNextArray = .NOT. MyLast                        ! Return true if valid array
-
-        return
+       TYPE(PeDef),POINTER          :: aPE
+       TYPE(ArrayDef),POINTER       :: ar
+
+       next_array_in_list = next_array_in_list+1
+
+!--    Array Names are the same on all client PE, so take first PE to get the name
+       aPE => me%PEs(1)
+
+       if(next_array_in_list > aPE%Nr_arrays) then
+          PMC_C_GetNextArray = .false.             !all arrays done
+          return
+       end if
+
+       ar  => aPE%array_list(next_array_in_list)
+
+       myName = ar%name
+
+       PMC_C_GetNextArray =  .true.                ! Return true if legal array
+       return
     END function PMC_C_GetNextArray
 
     SUBROUTINE PMC_C_Set_DataArray_2d (array)
+
        IMPLICIT none
-!--    TO_DO: is double precision absolutely required here?
-       REAL(kind=dp),INTENT(IN),DIMENSION(:,:)    :: array
-       !-- local variables
-       INTEGER                           :: NrDims
-       INTEGER,DIMENSION (4)             :: dims
-       INTEGER                           :: dim_order
-       TYPE(c_ptr)                       :: array_adr
-       INTEGER                           :: i
-       TYPE(PeDef),POINTER               :: aPE
-       TYPE(ArrayDef),POINTER            :: ar
+
+       REAL(wp), INTENT(IN) ,DIMENSION(:,:) ::  array
+
+       INTEGER                              :: NrDims
+       INTEGER,DIMENSION (4)                :: dims
+       TYPE(c_ptr)                          :: array_adr
+       INTEGER                              :: i
+       TYPE(PeDef),POINTER                  :: aPE
+       TYPE(ArrayDef),POINTER               :: ar
 
 
@@ -338,5 +350,4 @@
        dims(1)   = size(array,1)
        dims(2)   = size(array,2)
-       dim_order = 2
 
        array_adr = c_loc(array)
@@ -344,8 +355,7 @@
        do i=1,me%inter_npes
           aPE => me%PEs(i)
-          ar  => aPE%Arrays
+          ar  => aPE%array_list(next_array_in_list)    !actual array is last array in list
           ar%NrDims    = NrDims
           ar%A_dim     = dims
-          ar%dim_order = dim_order
           ar%data      = array_adr
        end do
@@ -355,15 +365,15 @@
 
     SUBROUTINE PMC_C_Set_DataArray_3d (array)
+
        IMPLICIT none
-!--    TO_DO: is double precision absolutely required here?
-       REAL(kind=dp),INTENT(IN),DIMENSION(:,:,:)  :: array
-       !-- local variables
-       INTEGER                           :: NrDims
-       INTEGER,DIMENSION (4)             :: dims
-       INTEGER                           :: dim_order
-       TYPE(c_ptr)                       :: array_adr
-       INTEGER                           :: i
-       TYPE(PeDef),POINTER               :: aPE
-       TYPE(ArrayDef),POINTER            :: ar
+
+       REAL(wp),INTENT(IN),DIMENSION(:,:,:) ::  array
+
+       INTEGER                              ::  NrDims
+       INTEGER,DIMENSION (4)                ::  dims
+       TYPE(c_ptr)                          ::  array_adr
+       INTEGER                              ::  i
+       TYPE(PeDef),POINTER                  ::  aPE
+       TYPE(ArrayDef),POINTER               ::  ar
 
        dims = 1
@@ -373,5 +383,4 @@
        dims(2)   = size(array,2)
        dims(3)   = size(array,3)
-       dim_order =33
 
        array_adr = c_loc(array)
@@ -379,8 +388,7 @@
        do i=1,me%inter_npes
           aPE => me%PEs(i)
-          ar  => aPE%Arrays
+          ar  => aPE%array_list(next_array_in_list)    !actual array is last array in list
           ar%NrDims    = NrDims
           ar%A_dim     = dims
-          ar%dim_order = dim_order
           ar%data      = array_adr
        end do
@@ -393,5 +401,5 @@
       IMPLICIT none
 
-      INTEGER                                 :: i, ierr
+      INTEGER                                 :: i, ierr, j
       INTEGER                                 :: arlen, myIndex, tag
       INTEGER(idp)                            :: bufsize                   ! Size of MPI data Window
@@ -412,6 +420,6 @@
          tag = 200
 
-         do while (PMC_C_GetNextArray (myName))
-            ar  => aPE%Arrays
+         do j=1,aPE%Nr_arrays
+            ar  => aPE%array_list(j)
 
             ! Receive Index from client
@@ -419,5 +427,5 @@
             CALL MPI_Recv (myIndex, 1, MPI_INTEGER, i-1, tag, me%inter_comm, MPI_STATUS_IGNORE, ierr)
 
-            if(ar%dim_order == 33) then                    ! PALM has k in first dimension
+            if(ar%NrDims == 3) then                    ! PALM has k in first dimension
                bufsize = max(bufsize,ar%A_dim(1)*ar%A_dim(2)*ar%A_dim(3))    ! determine max, because client buffer is allocated only once
             else
@@ -442,6 +450,6 @@
          aPE => me%PEs(i)
 
-         do while (PMC_C_GetNextArray (myName))
-            ar  => aPE%Arrays
+         do j=1,aPE%Nr_arrays
+            ar  => aPE%array_list(j)
             ar%SendBuf = base_ptr
          end do
@@ -452,25 +460,27 @@
 
    SUBROUTINE PMC_C_GetBuffer (WaitTime)
+
       IMPLICIT none
-      REAL(kind=dp),INTENT(OUT),optional         :: WaitTime
+
+      REAL(wp), INTENT(OUT), optional   ::  WaitTime
 
       !-- local variables
-      INTEGER                                 :: ip, ij, ierr
-      INTEGER                                 :: nr                 ! Number of Elements to getb from server
-      INTEGER                                 :: myIndex
-      REAL(kind=dp)                           :: t1,t2
-      TYPE(PeDef),POINTER                     :: aPE
-      TYPE(ArrayDef),POINTER                  :: ar
-      INTEGER,DIMENSION(1)                    :: buf_shape
-      REAL(kind=wp),POINTER,DIMENSION(:)      :: buf
-      REAL(kind=wp),POINTER,DIMENSION(:,:)    :: data_2d
-      REAL(kind=wp),POINTER,DIMENSION(:,:,:)  :: data_3d
-      character(len=DA_Namelen)               :: myName
-      INTEGER(kind=MPI_ADDRESS_KIND)          :: target_disp
+      INTEGER                           ::  ip, ij, ierr, j
+      INTEGER                           ::  nr  ! Number of Elements to getb from server
+      INTEGER                           ::  myIndex
+      REAL(wp)                          ::  t1,t2
+      TYPE(PeDef),POINTER               ::  aPE
+      TYPE(ArrayDef),POINTER            ::  ar
+      INTEGER,DIMENSION(1)              ::  buf_shape
+      REAL(wp),POINTER,DIMENSION(:)     ::  buf
+      REAL(wp),POINTER,DIMENSION(:,:)   ::  data_2d
+      REAL(wp),POINTER,DIMENSION(:,:,:) ::  data_3d
+      character(len=DA_Namelen)         ::  myName
+      INTEGER(kind=MPI_ADDRESS_KIND)    ::  target_disp
 
       t1 = PMC_Time()
       CALL MPI_Barrier(me%intra_comm, ierr)                         ! Wait for server to fill buffer
-      t2 = PMC_Time()
-      if(present(WaitTime)) WaitTime = t2-t1
+      t2 = PMC_Time()-t1
+      if(present(WaitTime)) WaitTime = t2
 
       CALL MPI_Barrier(me%intra_comm, ierr)                         ! Wait for buffer is filled
@@ -479,9 +489,9 @@
          aPE => me%PEs(ip)
 
-         do while (PMC_C_GetNextArray (myName))
-            ar  => aPE%Arrays
-            if(ar%dim_order == 2) then
+         do j=1,aPE%Nr_arrays
+            ar  => aPE%array_list(j)
+            if(ar%NrDims == 2) then
                nr = aPE%NrEle
-            else if(ar%dim_order == 33) then
+            else if(ar%NrDims == 3) then
                nr = aPE%NrEle*ar%A_dim(1)
             end if
@@ -489,5 +499,6 @@
             buf_shape(1) = nr
             CALL c_f_pointer(ar%SendBuf, buf, buf_shape)
-
+!
+!--         MPI passive target RMA
             if(nr > 0)   then
                target_disp = (ar%BufIndex-1)
@@ -498,5 +509,5 @@
 
             myIndex = 1
-            if(ar%dim_order == 2) then
+            if(ar%NrDims == 2) then
 
                CALL c_f_pointer(ar%data, data_2d, ar%A_dim(1:2))
@@ -505,5 +516,5 @@
                   myIndex = myIndex+1
                end do
-            else if(ar%dim_order == 33) then
+            else if(ar%NrDims == 3) then
                CALL c_f_pointer(ar%data, data_3d, ar%A_dim(1:3))
                do ij=1,aPE%NrEle
@@ -519,20 +530,22 @@
 
    SUBROUTINE PMC_C_PutBuffer (WaitTime)
+
       IMPLICIT none
-      REAL(kind=dp),INTENT(OUT),optional         :: WaitTime
+
+      REAL(wp), INTENT(OUT), optional   :: WaitTime
 
       !-- local variables
-      INTEGER                                 :: ip, ij, ierr
-      INTEGER                                 :: nr                 ! Number of Elements to getb from server
-      INTEGER                                 :: myIndex
-      REAL(kind=dp)                           :: t1,t2
-      TYPE(PeDef),POINTER                     :: aPE
-      TYPE(ArrayDef),POINTER                  :: ar
-      INTEGER,DIMENSION(1)                    :: buf_shape
-      REAL(kind=wp),POINTER,DIMENSION(:)      :: buf
-      REAL(kind=wp),POINTER,DIMENSION(:,:)    :: data_2d
-      REAL(kind=wp),POINTER,DIMENSION(:,:,:)  :: data_3d
-      character(len=DA_Namelen)               :: myName
-      INTEGER(kind=MPI_ADDRESS_KIND)          :: target_disp
+      INTEGER                           ::  ip, ij, ierr, j
+      INTEGER                           ::  nr  ! Number of Elements to getb from server
+      INTEGER                           ::  myIndex
+      REAL(wp)                          ::  t1,t2
+      TYPE(PeDef),POINTER               ::  aPE
+      TYPE(ArrayDef),POINTER            ::  ar
+      INTEGER,DIMENSION(1)              ::  buf_shape
+      REAL(wp),POINTER,DIMENSION(:)     ::  buf
+      REAL(wp),POINTER,DIMENSION(:,:)   ::  data_2d
+      REAL(wp),POINTER,DIMENSION(:,:,:) ::  data_3d
+      character(len=DA_Namelen)         ::  myName
+      INTEGER(kind=MPI_ADDRESS_KIND)    ::  target_disp
 
 
@@ -540,9 +553,9 @@
          aPE => me%PEs(ip)
 
-         do while (PMC_C_GetNextArray (myName))
-            ar  => aPE%Arrays
-            if(ar%dim_order == 2) then
+         do j=1,aPE%Nr_arrays
+            ar  => aPE%array_list(j)
+            if(ar%NrDims == 2) then
                nr = aPE%NrEle
-            else if(ar%dim_order == 33) then
+            else if(ar%NrDims == 3) then
                nr = aPE%NrEle*ar%A_dim(1)
             end if
@@ -552,5 +565,5 @@
 
             myIndex = 1
-            if(ar%dim_order == 2) then
+            if(ar%NrDims == 2) then
                CALL c_f_pointer(ar%data, data_2d, ar%A_dim(1:2))
                do ij=1,aPE%NrEle
@@ -558,5 +571,5 @@
                   myIndex = myIndex+1
                end do
-            else if(ar%dim_order == 33) then
+            else if(ar%NrDims == 3) then
                CALL c_f_pointer(ar%data, data_3d, ar%A_dim(1:3))
                do ij=1,aPE%NrEle
@@ -565,5 +578,6 @@
                end do
             end if
-
+!
+!--         MPI passiv target RMA
             if(nr > 0)   then
                target_disp = (ar%BufIndex-1)
Index: palm/trunk/SOURCE/pmc_general.f90
===================================================================
--- palm/trunk/SOURCE/pmc_general.f90	(revision 1777)
+++ palm/trunk/SOURCE/pmc_general.f90	(revision 1779)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! PMC_MPI_REAL removed, dim_order removed from type arraydef,
+! array management changed from linked list to sequential loop
 !
 ! Former revisions:
@@ -62,7 +63,6 @@
    INTEGER,parameter,PUBLIC              :: PMC_DA_NAME_ERR  = 10
 
+   INTEGER,parameter,PUBLIC              :: PMC_MAX_ARRAY    = 32  !Max Number of Array which can be coupled
    INTEGER,parameter,PUBLIC              :: PMC_MAX_MODELL   = 64
-!  TO_DO: the next variable doesn't seem to be used.  Remove?
-   INTEGER,parameter,PUBLIC              :: PMC_MPI_REAL     = MPI_DOUBLE_PRECISION
    INTEGER,parameter,PUBLIC              :: DA_Desclen       = 8
    INTEGER,parameter,PUBLIC              :: DA_Namelen       = 16
@@ -77,5 +77,4 @@
       INTEGER                       :: NrDims                      ! Number of Dimensions
       INTEGER,DIMENSION(4)          :: A_dim                       ! Size of dimensions
-      INTEGER                       :: dim_order                   ! Order of Dimensions: 2 = 2D array, 33 = 3D array
       TYPE(c_ptr)                   :: data                        ! Pointer of data in server space
       TYPE(c_ptr), DIMENSION(2)     :: po_data                     ! Base Pointers, PMC_S_Set_Active_data_array sets active pointer
@@ -91,8 +90,8 @@
 
    TYPE, PUBLIC :: PeDef
-      INTEGER(idp)                        :: NrEle                 ! Number of Elemets
-      TYPE (xy_ind), POINTER,DIMENSION(:) :: locInd                ! xy index local array for remote PE
-      TYPE( ArrayDef), POINTER            :: Arrays                ! Pointer to Data Array List (Type ArrayDef)
-      TYPE( ArrayDef), POINTER            :: ArrayStart            ! Pointer to Star of the List
+      INTEGER                                :: Nr_arrays=0        ! Number of arrays which will be transfered in this run
+      INTEGER                                :: NrEle              ! Number of Elemets, same for all arrays
+      TYPE (xy_ind), POINTER,DIMENSION(:)    :: locInd             ! xy index local array for remote PE
+      TYPE( ArrayDef), POINTER, DIMENSION(:) :: array_list         ! List of Data Arrays to be transfered
    END TYPE PeDef
 
@@ -122,13 +121,9 @@
     end INTERFACE PMC_G_SetName
 
-    INTERFACE PMC_G_GetName
-       MODULE procedure PMC_G_GetName
-    end INTERFACE PMC_G_GetName
-
     INTERFACE PMC_sort
        MODULE procedure sort_2d_i
     end INTERFACE PMC_sort
 
-    PUBLIC PMC_G_SetName, PMC_G_GetName, PMC_sort
+    PUBLIC PMC_G_SetName, PMC_sort
 
 
@@ -145,15 +140,12 @@
        TYPE(PeDef),POINTER                     :: aPE
 
+!
+!--    Assign array to next free index in array_list.
+!--    Set name of array in ArrayDef structure
        do i=1,myClient%inter_npes
           aPE => myClient%PEs(i)
-          ar  => aPE%Arrays
-          if(.not. associated (ar) )  then
-             ar => DA_List_append (ar, couple_index)
-             aPE%ArrayStart => ar
-         else
-             ar => DA_List_append (ar, couple_index)
-           endif
-          Ar%Name    = trim(aName) // " "
-          myClient%PEs(i)%Arrays => ar
+          aPE%Nr_arrays = aPE%Nr_arrays+1
+          aPE%array_list(aPE%Nr_arrays)%name        = aName
+          aPE%array_list(aPE%Nr_arrays)%coupleIndex = couple_index
        end do
 
@@ -161,57 +153,4 @@
     end SUBROUTINE PMC_G_SetName
 
-    SUBROUTINE PMC_G_GetName (myClient, couple_index, aName, aLast,Client_PeIndex)
-       IMPLICIT none
-
-       TYPE(ClientDef),INTENT(INOUT)           :: myClient
-       INTEGER,INTENT(OUT)                     :: couple_index
-       CHARACTER(LEN=*),INTENT(OUT)            :: aName
-       logical,INTENT(OUT)                     :: aLast
-       INTEGER,INTENT(IN),optional             :: Client_PeIndex
-
-       INTEGER                                 :: i,istart,istop
-       TYPE(PeDef),POINTER                     :: aPE
-       TYPE(ArrayDef),POINTER                  :: ar
-       logical,save                            :: first=.true.
-
-       aLast = .false.
-
-       if(present(Client_PeIndex))  then       !Loop over all Client PEs or just one selected via Client_PeIndex
-          istart = Client_PeIndex
-          istop  = Client_PeIndex
-       else
-          istart = 1
-          istop  = myClient%inter_npes
-       end if
-
-       do i=istart,istop
-          aPE => myClient%PEs(i)
-          ar  => aPE%Arrays
-          if(first)  then
-             ar => aPE%ArrayStart
-          else
-             ar => aPE%Arrays
-             ar => DA_List_next (ar)
-             if(.not. associated (ar) )  then
-                aLast = .true.
-                first = .true.                                  !Reset linked list to begin
-                aPE%Arrays => ar
-              end if
-          endif
-          aPE%Arrays => ar
-       end do
-       if(aLast) then
-          return
-       end if
-
-       couple_index = ar%coupleIndex
-       aName        = ar%Name
-       aLast        = .false.
-
-       first = .false.
-
-
-       return
-    END SUBROUTINE PMC_G_GetName
 
     SUBROUTINE sort_2d_i (array,sort_ind)
@@ -238,39 +177,4 @@
     END  SUBROUTINE sort_2d_i
 
-!   Private section
-!   linked List routines for Data Array handling
-
-    FUNCTION DA_List_append   (node, couple_index)
-       TYPE(ArrayDef),POINTER      :: DA_List_append
-       TYPE(ArrayDef),POINTER      :: node
-       INTEGER,INTENT(IN)          :: couple_index
-
-!--    local variables
-       TYPE(ArrayDef),POINTER      :: ar
-
-       if(.not. associated (node))   then
-          ALLOCATE(ar)
-          ar%coupleIndex = couple_index
-          NULLIFY(ar%next)
-          DA_List_append => ar
-       else
-          ALLOCATE(node%next)
-          node%next%coupleIndex = couple_index
-          NULLIFY(node%next%next)
-          DA_List_append => node%next
-       end if
-
-       return
-    END FUNCTION DA_List_append
-
-    FUNCTION DA_List_next   (node)
-       TYPE(ArrayDef),POINTER      :: DA_List_next
-       TYPE(ArrayDef),POINTER      :: node
-
-       DA_List_next => node%next
-
-       return
-    END FUNCTION DA_List_next
-
 #endif
 end MODULE pmc_general
Index: palm/trunk/SOURCE/pmc_handle_communicator.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1777)
+++ palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1779)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! only the total number of PEs is given in the nestpar-NAMELIST,
+! additional comments included
 !
 ! Former revisions:
@@ -62,6 +63,5 @@
       INTEGER  ::  id
       INTEGER  ::  parent_id
-      INTEGER  ::  npe_x
-      INTEGER  ::  npe_y
+      INTEGER  ::  npe_total
 
       REAL(wp) ::  lower_left_x
@@ -155,6 +155,5 @@
             start_pe(1) = 0
             DO  i = 2, m_nrofcpl+1
-               start_pe(i) = start_pe(i-1) +                                   &
-                             m_couplers(i-1)%npe_x * m_couplers(i-1)%npe_y
+               start_pe(i) = start_pe(i-1) + m_couplers(i-1)%npe_total
             ENDDO
 
@@ -162,14 +161,10 @@
 !--         The number of cores provided with the run must be the same as the
 !--         total sum of cores required by all nest domains
-!--         TO_DO: can we use > instead of /= ?
             IF ( start_pe(m_nrofcpl+1) /= m_world_npes )  THEN
-!--            TO_DO: this IF statement is redundant
-               IF ( m_world_rank == 0 )  THEN
-                  WRITE ( message_string, '(A,I6,A,I6,A)' )                    &
-                                  'nesting-setup requires more MPI procs (',   &
-                                  start_pe(m_nrofcpl+1), ') than provided (',  &
-                                  m_world_npes,')'
-                  CALL message( 'pmc_init_model', 'PA0229', 3, 2, 0, 6, 0 )
-               ENDIF
+               WRITE ( message_string, '(A,I6,A,I6,A)' )                       &
+                               'nesting-setup requires more MPI procs (',      &
+                               start_pe(m_nrofcpl+1), ') than provided (',     &
+                               m_world_npes,')'
+               CALL message( 'pmc_init_model', 'PA0229', 3, 2, 0, 6, 0 )
             ENDIF
 
@@ -210,6 +205,5 @@
          CALL MPI_BCAST( m_couplers(i)%id,           1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
          CALL MPI_BCAST( m_couplers(i)%Parent_id,    1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
-         CALL MPI_BCAST( m_couplers(i)%npe_x,        1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
-         CALL MPI_BCAST( m_couplers(i)%npe_y,        1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
+         CALL MPI_BCAST( m_couplers(i)%npe_total,    1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
          CALL MPI_BCAST( m_couplers(i)%lower_left_x, 1, MPI_REAL,    0, MPI_COMM_WORLD, istat )
          CALL MPI_BCAST( m_couplers(i)%lower_left_y, 1, MPI_REAL,    0, MPI_COMM_WORLD, istat )
@@ -233,12 +227,4 @@
       CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, m_my_cpl_id, m_my_cpl_rank, comm,   &
                            istat )
-      IF ( istat /= MPI_SUCCESS )  THEN
-!
-!--      TO_DO: replace by message-call
-!--      TO_DO: Can this really happen, or is this just for the debugging phase?
-         IF ( m_world_rank == 0 )  WRITE (0,*) 'PMC: Error in MPI_Comm_split '
-         CALL MPI_ABORT( MPI_COMM_WORLD, ierr, istat )
-      ENDIF
-
 !
 !--   Get size and rank of the model running on this PE
@@ -256,5 +242,5 @@
 
 !
-!--   TO_DO: describe what is happening here, and why
+!--   Save the current model communicator for PMC internal use
       m_model_comm = comm
 
@@ -268,6 +254,8 @@
          IF ( m_couplers(i)%parent_id == m_my_cpl_id )  THEN
 !
-!--         Collect server PEs
-!--         TO_DO: explain in more details, what is done here
+!--         Collect server PEs.
+!--         Every model exept the root model has a parent model which acts as
+!--         server model. Create an intercommunicator to connect current PE to
+!--         all client PEs
             tag = 500 + i
             CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD, start_pe(i),   &
@@ -278,18 +266,12 @@
          ELSEIF ( i == m_my_cpl_id)  THEN
 !
-!--         Collect client PEs
-!--         TO_DO: explain in more detail, what is happening here
+!--         Collect client PEs.
+!--         Every model exept the root model has a paremt model which acts as
+!--         server model. Create an intercommunicator to connect current PE to
+!--         all server PEs
             tag = 500 + i
             CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD,                &
                                        start_pe(m_couplers(i)%parent_id),      &
                                        tag, m_to_server_comm, istat )
-         ENDIF
-
-         IF ( istat /= MPI_SUCCESS )  THEN
-!
-!--         TO_DO: replace by message-call
-!--         TO_DO: can this really happen, or is this just for debugging?
-            IF ( m_world_rank == 0 )  WRITE (0,*) 'PMC: Error in Coupler Setup '
-            CALL MPI_ABORT( MPI_COMM_WORLD, ierr, istat )
          ENDIF
 
@@ -309,10 +291,6 @@
          ENDIF
       ENDDO
-!--   TO_DO: explain why this is done
-      pmc_server_for_client(clientcount+1) = -1
-
 !
 !--   Get the size of the server model
-!--   TO_DO: what does "size" mean here? Number of PEs?
       IF ( m_my_cpl_id > 1 )  THEN
          CALL MPI_COMM_REMOTE_SIZE( m_to_server_comm, m_server_remote_size,    &
@@ -337,9 +315,6 @@
 !
 !-- Make module private variables available to palm
-!-- TO_DO: why can't they be available from the beginning, i.e. why do they
-!--        first have to be declared as different private variables?
    SUBROUTINE pmc_get_local_model_info( my_cpl_id, my_cpl_parent_id, cpl_name, &
-                                        npe_x, npe_y, lower_left_x,            &
-                                        lower_left_y )
+                                        npe_total, lower_left_x, lower_left_y )
 
       USE kinds
@@ -350,15 +325,12 @@
       INTEGER, INTENT(OUT), OPTIONAL          ::  my_cpl_id
       INTEGER, INTENT(OUT), OPTIONAL          ::  my_cpl_parent_id
-      INTEGER, INTENT(OUT), OPTIONAL          ::  npe_x
-      INTEGER, INTENT(OUT), OPTIONAL          ::  npe_y
+      INTEGER, INTENT(OUT), OPTIONAL          ::  npe_total
       REAL(wp), INTENT(OUT), OPTIONAL         ::  lower_left_x
       REAL(wp), INTENT(OUT), OPTIONAL         ::  lower_left_y
 
-!--   TO_DO: is the PRESENT clause really required here?
       IF ( PRESENT( my_cpl_id )           )  my_cpl_id        = m_my_cpl_id
       IF ( PRESENT( my_cpl_parent_id )    )  my_cpl_parent_id = m_couplers(my_cpl_id)%parent_id
       IF ( PRESENT( cpl_name )            )  cpl_name         = m_couplers(my_cpl_id)%name
-      IF ( PRESENT( npe_x )               )  npe_x            = m_couplers(my_cpl_id)%npe_x
-      IF ( PRESENT( npe_y )               )  npe_y            = m_couplers(my_cpl_id)%npe_y
+      IF ( PRESENT( npe_total )           )  npe_total        = m_couplers(my_cpl_id)%npe_total
       IF ( PRESENT( lower_left_x )        )  lower_left_x     = m_couplers(my_cpl_id)%lower_left_x
       IF ( PRESENT( lower_left_y )        )  lower_left_y     = m_couplers(my_cpl_id)%lower_left_y
@@ -378,7 +350,4 @@
 
 
-
-!-- TO_DO: what does this comment mean?
-! Private SUBROUTINEs
  SUBROUTINE read_coupling_layout( nesting_mode, pmc_status )
 
@@ -438,9 +407,9 @@
 
        IF ( m_couplers(i)%id /= -1  .AND.  i <= pmc_max_modell )  THEN
-          WRITE ( 0, '(A,A,1X,4I7,1X,2F10.2)' )  'Set up Model  ',             &
-                              TRIM( m_couplers(i)%name ), m_couplers(i)%id,    &
-                              m_couplers(i)%Parent_id, m_couplers(i)%npe_x,    &
-                              m_couplers(i)%npe_y, m_couplers(i)%lower_left_x, &
-                              m_couplers(i)%lower_left_y
+          WRITE ( 0, '(A,A,1X,3I7,1X,2F10.2)' )  'Set up Model  ',             &
+                             TRIM( m_couplers(i)%name ), m_couplers(i)%id,     &
+                             m_couplers(i)%Parent_id, m_couplers(i)%npe_total, &
+                             m_couplers(i)%lower_left_x,                       &
+                             m_couplers(i)%lower_left_y
        ELSE
 !
